package com.eco.plugin.xxx.jmcwmsg.dsdd.db;

import com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd.TsEntity;
import com.fr.decision.plugin.db.AbstractDecisionDBAccessProvider;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;

public class DBAccessProvider extends AbstractDecisionDBAccessProvider {
    private static DBAccessor dbAccessor = null;

    public static DBAccessor getDbAccessor(){
        return dbAccessor;
    }


    @Override
    public DAOProvider[] registerDAO() {
        return new DAOProvider[]{
                new DAOProvider() {
                    @Override
                    public Class getEntityClass() {
                        return TsEntity.class;
                    }

                    @Override
                    public Class<? extends BaseDAO> getDAOClass() {
                        return Dao.class;
                    }
                }
        };
    }

    @Override
    public void onDBAvailable(DBAccessor dbAccessor) {
        this.dbAccessor = dbAccessor;
    }
}
