
BI.config("dec.provider.schedule", function (provider) {
    provider.registerHandingWay({
        text: "消息推送",
        value:"com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd.TsBean",
        cardType: "dec.schedule.task.file.handling.oa",
        actions: [] // action
    }, [DecCst.Schedule.TaskType.DEFAULT, DecCst.Schedule.TaskType.REPORT, DecCst.Schedule.TaskType.BI]);
});

var Plugin = BI.inherit(BI.Widget, {
    props: {
        baseCls: ""
    },
    _store: function () {
        return BI.Models.getModel("dec.model.schedule.task.file.handling.oa")
    },
    watch: {
        linkType: function (e) {
            this.linkGroup.setValue(e),
                this.customizeLinkText.setVisible(e === DecCst.Schedule.MessageUrl.Type.OUT)
        },
        type:function(e){
                this.title.setVisible(e*1 !== 1)
        },
        linkGroupItems: function (e) {
            this.linkGroup.populate(BI.createItems(e, {
                type: "bi.single_select_radio_item",
                logic: {
                    dynamic: !0
                }
            })),
            this.model.isNotReportTask && this.store.setLinkType(DecCst.Schedule.MessageUrl.Type.OUT)
        }
    },
    render: function () {
        var t = this,
            e = this.options.value[0],
            n = this;

        if(e == undefined){
            e = {};
        }
        // this.store.setLinkType(e.linkOpenType*1);
        // this.store.setType(e.type*1);

        return {
            type: "bi.vertical",
            tgap: 15,
            items: [{
                type: "bi.horizontal_adapt",
                columnSize: [115, "fill"],
                items: [{
                    type: "bi.label",
                    cls: "dec-font-weight-bold",
                    width: 115,
                    height: 24,
                    textAlign: "left",
                    text: "消息类型"
                },  {
                    type: "dec.label.editor.item",
                    textCls: "dec-font-weight-bold",
                    height: 24,
                    // lgap: 20,
                    invisible: 0,
                    textWidth: "",
                    watermark: "",
                    editorWidth: 300,
                    value: e.msgtype,
                    ref: function (e) {
                        n.msgtype = e
                    }
                }
                ]
            }, {
                    type: "bi.horizontal_adapt",
                    columnSize: [115, "fill"],
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        width: 115,
                        height: 24,
                        textAlign: "left",
                        text: "标题"
                    },  {
                        type: "dec.label.editor.item",
                        textCls: "dec-font-weight-bold",
                        height: 24,
                        // lgap: 20,
                        invisible: 0,
                        textWidth: "",
                        watermark: "标题",
                        editorWidth: 300,
                        value: e.title,
                        ref: function (e) {
                            n.title = e
                        }
                    }
                    ]
                },
                {
                    type: "bi.horizontal_adapt",
                    columnSize: [115, "fill"],
                    items: [{
                        type: "bi.label",
                        cls: "dec-font-weight-bold",
                        width: 115,
                        height: 24,
                        textAlign: "left",
                        text: BI.i18nText("Dec-Basic_Content")
                    }, {
                        type: "dec.error_label",
                        height: 100,
                        el: {
                            type: "bi.textarea_editor",
                            cls: "bi-border",
                            width: 300,
                            height: 98,
                            watermark: "内容",
                            ref: function (e) {
                                n.contentText = e
                            },
                            value:e.content,
                            listeners: [{
                                eventName: BI.TextAreaEditor.EVENT_FOCUS,
                                action: function () {
                                    n.contentBubbles.hideError()
                                }
                            }, {
                                eventName: BI.TextAreaEditor.EVENT_CHANGE,
                                action: function () {
                                    n.contentBubbles.hideError()
                                }
                            }
                            ]
                        },
                        ref: function (e) {
                            n.contentBubbles = e
                        }
                    }
                    ]
                }
            ]
        }
    },
    /**
     *
     *
     * @returns {boolean}
     */
    validation: function () {
        return true;
    },
    setValue: function (e) {
        var t = this;
        BI.map(e, function (e, i) {
            if (i.runType === DecCst.Schedule.RunType.CLIENT_NOTIFICATION)
            {
                t.contentText.setValue(i.content), t.title.setValue(i.title), t.msgtype.setValue(i.msgtype)
            }
        })
    },

    /**
     *
     * outputActionList
     * @returns {{}}
     */
    getValue: function () {
        return {
            "@class": "com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd.TsBean",
            actionName: "com.eco.plugin.xxx.jmcwmsg.dsdd.dsdd.TsBean",
            content: this.contentText.getValue(),
            msgtype:this.msgtype.getValue(),
            title:this.title.getValue()
        }
    }
});
BI.shortcut("dec.schedule.task.file.handling.oa", Plugin);

//数据
var e = BI.inherit(Fix.Model, {
    context: ["currTask"],
    state: function () {
        return {
            linkType: DecCst.Schedule.MessageUrl.Type.INNER,
            type:1
        }
    },
    computed: {
        isBITask: function () {
            return this.model.currTask.taskType === DecCst.Schedule.TaskType.BI
        },
        isNotReportTask: function () {
            return this.model.currTask.taskType !== DecCst.Schedule.TaskType.REPORT
        },
        linkGroupItems: function () {
            var e = BI.deepClone(BI.Constants.getConstant("dec.constant.schedule.task.handing.client.link"));
            return this.model.isNotReportTask ? (e[0].disabled = !0, e[0].selected = !1, e[1].selected = !0, this.setLinkType(DecCst.Schedule.MessageUrl.Type.OUT)) : (e[0].disabled = !1, e[0].selected = this.model.linkType === DecCst.Schedule.MessageUrl.Type.INNER, e[1].selected = this.model.linkType === DecCst.Schedule.MessageUrl.Type.OUT),
                e
        },
        typeGroupItems: function () {
            return [{disabled:false,selected:true,text:'消息推送',value:'1'},{disabled:false,selected:false,text:'代办推送',value:'2'}]
        }
    },
    actions: {
        setLinkType: function (e) {
            this.model.linkType = e
        },
        setType: function(e){
            this.model.type = e;
        }
    }
});
BI.model("dec.model.schedule.task.file.handling.oa", e)


//处理空数组问题
var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-schedule-task-handling",
        $testId: "dec-schedule-task-handling",
        value: {
            scheduleOutput: {
                outputActionList: []
            }
        }
    },
    _store: function () {
        return BI.Models.getModel("dec.model.schedule.task.handling", {
            value: this.options.value
        })
    },
    watch: {
        selectedWay: function (e) {
            this.leftGroup.populate(this._createLeftItems(e)),
                this.leftGroup.setValue(this.model.leftTab),
                this.handlingWayGroup.setValue(e)
        },
        leftTab: function (e) {
            this.centerTab.setSelect(e)
        },
        topItems: function (e) {
            this.handlingWayGroup.populate(e),
                this.handlingWayGroup.setValue(this.model.selectedWay)
        },
        taskType: function () {
            this.centerTab.empty()
        }
    },
    render: function () {
        var i = this;
        return {
            type: "bi.vertical",
            items: [{
                el: {
                    type: "bi.vertical",
                    bgap: 5,
                    items: [{
                        type: "bi.absolute",
                        items: [{
                            el: {
                                type: "bi.horizontal",
                                tgap: 5,
                                items: [{
                                    type: "bi.label",
                                    height: 24,
                                    cls: "dec-font-weight-bold",
                                    text: BI.i18nText("Dec-Task_Handling"),
                                    textAlign: "left"
                                }
                                ]
                            },
                            left: 0,
                            top: 0
                        }
                        ]
                    }, {
                        el: {
                            type: "bi.button_group",
                            layouts: [{
                                type: "bi.left",
                                lgap: 40,
                                bgap: 15
                            }
                            ],
                            chooseType: BI.ButtonGroup.CHOOSE_TYPE_MULTI,
                            items: this.model.topItems,
                            value: this.model.selectedWay,
                            ref: function (e) {
                                i.handlingWayGroup = e
                            },
                            listeners: [{
                                eventName: BI.ButtonGroup.EVENT_CHANGE,
                                action: function (e, t) {
                                    i.store.setHandlingWay(e, t.isSelected())
                                }
                            }
                            ]
                        },
                        lgap: 50
                    }
                    ]
                },
                tgap: 10
            }, {
                type: "bi.htape",
                cls: "handling-body bi-border-top",
                items: [{
                    type: "bi.button_group",
                    cls: "bi-border-right",
                    width: 200,
                    layouts: [{
                        type: "bi.vertical"
                    }
                    ],
                    items: this._createLeftItems(this.model.selectedWay),
                    value: this.model.leftTab,
                    ref: function (e) {
                        i.leftGroup = e
                    },
                    listeners: [{
                        eventName: BI.ButtonGroup.EVENT_CHANGE,
                        action: function (e) {
                            i.store.setLeftTab(e)
                        }
                    }
                    ]
                }, {
                    type: "bi.absolute",
                    items: [{
                        el: {
                            type: "bi.tab",
                            showIndex: this.model.leftTab,
                            cardCreator: BI.bind(i._cardCreator, this),
                            ref: function (e) {
                                i.centerTab = e
                            }
                        },
                        top: 0,
                        left: 15,
                        bottom: 0,
                        right: 0
                    }
                    ]
                }
                ]
            }
            ]
        }
    },
    validation: function (e) {
        var n = this,
            o = [],
            r = n.model.handlingItems;
        BI.each(this.model.editingWay, function (e, t) {
            var i = n[t + "Pane"];
            if (!BI.isFunction(i.validation) || i.validation()) {
                if (!BI.isNull(i.getValue()))
                    return !0;
                o.push(r[t].text)
            } else
                o.push(r[t].text)
        }),
        0 < BI.size(o) && BI.Msg.alert(BI.i18nText("Dec-Basic_Tips"), BI.i18nText("Dec-Error_Task_File_Handling_Value", o.join(","))),
            e(0 === BI.size(o))
    },
    getValue: function () {
        var i = {};
        BI.each(this.model.outputActionList, function (e, t) {
            i[t.actionName] = t
        });
        var o = {},
            r = [],
            s = [],
            a = [],
            e = this.model.editingWay,
            c = this,
            l = c.model.handlingItems;
        BI.each(e, function (e, t) {
            var i,
                n = c[t + "Pane"];
            n && BI.isNotEmptyObject(n.getValue()) && ((i = n.getValue(), BI.isNotNull(l[t].actions) && l[t].actions.length > 0) ? (r.push(t), BI.each(i, function (e, t) {
                var i = t.actionName;
                r.push(i),
                    o[i] = t
            }), s = BI.concat(s, BI.difference(l[t].actions, r))) : (r.push(t), o[t] = i), a.push(l[t].runType))
        });
        var t = BI.filter(i, function (e, t) {
            return c.store.isDefaultByRunType(t, a) || c.store.isDefaultValueItem(t, r, s)
        });
        return {
            scheduleOutput: BI.extend({}, this.model.currTask.scheduleOutput, {
                outputActionList: BI.map(o, function (e, t) {
                    return delete t.runType,
                        BI.extend({
                            resultURL: window.location.protocol + "//" + window.location.host + Dec.fineServletURL
                        }, t)
                }).concat(t)
            })
        }
    },
    _cardCreator: function (i) {
        var t = this,
            e = BI.find(this.model.handlingItems, function (e, t) {
                return t.value === i
            });
        return e && BI.isKey(e.cardType) ? {
                type: e.cardType,
                value: this.store.findActionValue(e, BI.deepClone(this.model.outputActionList)),
                ref: function (e) {
                    t[i + "Pane"] = e
                }
            }
            : {
                type: "bi.label",
                text: i
            }
    },
    _createLeftItems: function (e) {
        var n = this;
        return BI.map(e, function (e, t) {
            var i = n.model.handlingItems[t].text;
            return {
                type: "dec.schedule.task.file.handling.item",
                text: i,
                value: t,
                listeners: [{
                    eventName: "EVENT_DELETE",
                    action: function () {
                        n.store.deleteAction(t, i)
                    }
                }
                ]
            }
        })
    }
});

BI.shortcut("dec.schedule.task.handling", e)